package tuwien.auto.eicl;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.InetSocketAddress;
import tuwien.auto.eicl.struct.cemi.*;

public class ULTest
{
	private ULTest()
	{
		UserLayer ul = null;
		char[] inC = {'a'};
		Boolean result = new Boolean(false);
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

		
		InetSocketAddress isa = findIPRouter();
		try
		{
			ul = new UserLayer(isa.getHostName(), isa.getPort());
			while (inC[0] != 'q')
			{
				in.read(inC);
				result = ul.readBool(new EIB_Address(512, true));
				System.out.println(result);
			}
		}
		catch (Exception e)
		{
			e.printStackTrace();
			System.out.println(e.getMessage());
			System.exit(1);
		}
		finally
		{
			ul.disconnect();
		}
	}

	
	
	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		new ULTest();
	}

	
	private InetSocketAddress findIPRouter()
	{
		Discoverer d = new Discoverer();
		
		// HPAI.setLocalIP(InetAddress.getByName(t_LocalIP.getText()));
		try
		{
			d.sendSearchRequest();
        
        	synchronized (this)
        	{
        		this.wait(2000);
        	}
        }
		catch (Exception e)
		{
			e.printStackTrace();
			System.exit(1);
		}
		
        InetSocketAddress[] isa = d.getSearchResponses();
        if (isa.length > 0)
        {
            for (int i = 0; i < isa.length; i++)
            {
                System.out.println(isa[i].getHostName());
            }
        }
        
        return isa[0];
	}
}
