/*
 Copyright (C) 2005 Bernhard Erb
 Copyright 2006 Contributors
 */

/*
 This program is free software; you can redistribute it and/or modify it under the terms of 
 the GNU General Public License as published by the Free Software Foundation; either 
 version 2 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with this program; 
 if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
 Boston, MA  02110-1301, USA.
 */

/* 
$Log: Dialog_Send.java,v $
Revision 1.14  2006/08/11 11:58:37  woif
Datapointtype
Some features added in EICLdemo

Revision 1.13  2006/08/10 14:11:55  woif
Bugfix: "Type not found" error corrected when writing 3BitControlled
Corrected some implemenation flaws in 3BitControlled class

Revision 1.12  2006/07/19 12:14:42  woif
Debug statements removed

Revision 1.11  2006/07/19 09:06:11  woif
Unknown

Revision 1.10  2006/01/11 19:07:35  gneug
Change log update

 */

package tuwien.auto.eicldemo.ui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JButton;
import javax.swing.JTextField;
import javax.swing.JFrame;
import tuwien.auto.eibpoints.*;
import tuwien.auto.eibxlator.*;
import tuwien.auto.eicl.*;
import tuwien.auto.eicl.struct.cemi.CEMI_L_DATA;
import tuwien.auto.eicl.struct.cemi.EIB_Address;
import tuwien.auto.eicl.util.*;

/**
 * This code was generated using CloudGarden's Jigloo SWT/Swing GUI Builder,
 * which is free for non-commercial use. If Jigloo is being used commercially
 * (ie, by a corporation, company or business for any purpose whatever) then you
 * should purchase a license for each developer using Jigloo. Please visit
 * www.cloudgarden.com for details. Use of Jigloo implies acceptance of these
 * licensing terms. ************************************* A COMMERCIAL LICENSE
 * HAS NOT BEEN PURCHASED for this machine, so Jigloo or this code cannot be
 * used legally for any corporate or commercial purpose.
 * *************************************
 */
public class Dialog_Send extends javax.swing.JDialog {
    public static final long serialVersionUID = 1;

    private JLabel l_Point;

    private JComboBox cb_Point;

    private JButton b_Send;

    private JButton b_Cancel;

    private JComboBox cb_Value;
    
    private JLabel l_minor;
    
    private JLabel l_minorCb;

    private JLabel l_Value;

    private JLabel l_ValueCb;

    private JLabel tf_Majortype;

    private JLabel l_Major;

    private Point[] points;

    private PointList pointList;

    private JTextField tf_Value;

    private JLabel tf_ValueType;

    // private CEMI_Connection tunnel;
    
    private UserLayer userLayer;

    public Dialog_Send(JFrame frame, PointList _PointList, CEMI_Connection _Tunnel) {
        super(frame);
        pointList = _PointList;
        points = pointList.getAllPoints();
        // tunnel = _Tunnel;
        userLayer = new UserLayer(_Tunnel);
        initGUI();
    }

    private void initGUI() {
        try {
            getContentPane().setLayout(null);
            
            this.setTitle("Write datapoint");
            {
                l_Point = new JLabel();
                this.getContentPane().add(l_Point);
                l_Point.setText("Point");
                l_Point.setBounds(10, 10, 50, 20);
            }
            {
                cb_Point = new JComboBox();
                for (int i = 0; i < points.length; i++) {
                    cb_Point.addItem(points[i].getDeviceName());
                }
                this.getContentPane().add(cb_Point);
                cb_Point.addItemListener(new DialogSend_cb_Point_ItemListener(this));
                cb_Point.setBounds(115, 10, 160, 20);
            }
            {
                l_Major = new JLabel();
                this.getContentPane().add(l_Major);
                l_Major.setText("Majortype");
                l_Major.setBounds(10, 35, 80, 20);
            }
            {
                tf_Majortype = new JLabel();
                this.getContentPane().add(tf_Majortype);
                tf_Majortype.setBounds(115, 35, 160, 20);
            }
            {
                l_minor = new JLabel();
                this.getContentPane().add(l_minor);
                l_minor.setText("Minortyp");
                l_minor.setBounds(10, 60, 80, 20);
            }
            {
                l_minorCb = new JLabel();
                this.getContentPane().add(l_minorCb);
                l_minorCb.setBounds(115, 60, 160, 20);
            }
            {
                l_Value = new JLabel();
                this.getContentPane().add(l_Value);
                l_Value.setText("Value");
                l_Value.setBounds(10, 110, 80, 20);
            }
            {
                cb_Value = new JComboBox();
                this.getContentPane().add(cb_Value);
                cb_Value.setBounds(115, 85, 160, 20);
            }
            {
                tf_Value = new JTextField();
                this.getContentPane().add(tf_Value);
                tf_Value.setBounds(115, 110, 125, 20);
                tf_Value.setVisible(false);
            }
            {
                tf_ValueType = new JLabel();
                tf_ValueType.setText("%");
                this.getContentPane().add(tf_ValueType);
                tf_ValueType.setBounds(240, 110, 40, 20);
                tf_ValueType.setVisible(false);
            }
            {
                l_ValueCb = new JLabel();
                l_ValueCb.setText("Value");
                this.getContentPane().add(l_ValueCb);
                l_ValueCb.setBounds(10, 85, 80, 20);
                l_ValueCb.setVisible(false);
            }

            {
                b_Cancel = new JButton();
                this.getContentPane().add(b_Cancel);
                b_Cancel.setText("Cancel");
                b_Cancel.setBounds(40, 140, 100, 20);
                b_Cancel.addActionListener(new DialogSend_Close_actionAdapter(this));
            }
            {
                b_Send = new JButton();
                this.getContentPane().add(b_Send);
                b_Send.setText("Send");
                b_Send.setBounds(145, 140, 100, 20);
                b_Send.addActionListener(new DialogSend_Send_actionAdapter(this));
            }
            setSize(290, 215);
            cb_Point_SelectionChanged(null);
        } catch (Exception e) {
            Main_Frame.showException(e.getMessage());
        }
    }

    public void cb_Point_SelectionChanged(ItemEvent e) {
        try {
            cb_Value.removeAllItems();
            if (cb_Point.getSelectedIndex() != -1) {
                Point p = points[cb_Point.getSelectedIndex()];
                tf_Majortype.setText(PDUXlatorList.getPointTypeMajor().getTypeDescription(
                        p.getMajorType()));
                l_minorCb.setText(PDUXlatorList.getPointPDUMinor(p.getMajorType()).get(p.getMinorType())[1]);
                if (p.getMajorType().equals(PDUXlatorList.TYPE_BOOLEAN[0])) {
                    String[] values = PDUXlatorList.getPointPDUMinor(p.getMajorType()).getTypeValues(
                            p.getMinorType());
                    for (int i = 0; i < values.length; i++) {
                        cb_Value.addItem(values[i]);
                    }
                    tf_Value.setVisible(false);
                    tf_ValueType.setVisible(false);
                    cb_Value.setVisible(true);
                    l_ValueCb.setVisible(true);
                    l_Value.setVisible(false);
                } else if (p.getMajorType().equals(PDUXlatorList.TYPE_8BIT_UNSIGNED[0])) {
                    tf_Value.setText("");
                    tf_Value.setVisible(true);
                    tf_ValueType.setVisible(true);
                    tf_ValueType.setText(PDUXlatorList.getPointPDUMinor(p.getMajorType()).getTypeValues(
                            p.getMinorType())[1]);
                    cb_Value.setVisible(false);
                    l_ValueCb.setVisible(false);
                    l_Value.setVisible(true);
                } else if (p.getMajorType().equals(PDUXlatorList.TYPE_3BIT_CONTROLLED[0])) {
                    tf_Value.setText("");
                     /*String[] values = PDUXlatorList.getPointPDUXlator(p.getMajorType(),
                            p.getMinorType()).getMinorTypes().getTypeValues(p.getMajorType());*/
                    String[] values = PDUXlatorList.getPointPDUMinor(p.getMajorType()).getTypeValues(
                            p.getMinorType());
                    for (int i = 0; i < values.length; i++) {
                        cb_Value.addItem(values[i]);
                    }

                    tf_Value.setVisible(true);
                    tf_ValueType.setVisible(true);
                    tf_ValueType.setText("steps");
                    cb_Value.setVisible(true);
                    l_Value.setVisible(true);
                    l_ValueCb.setVisible(true);
                } else if (p.getMajorType().equals(PDUXlatorList.TYPE_2BYTE_FLOAT[0])) {
                    tf_Value.setText("");
                    tf_Value.setVisible(true);
                    tf_ValueType.setVisible(true);
                    tf_ValueType.setText(PDUXlatorList.getPointPDUMinor(p.getMajorType()).getTypeValues(
                            p.getMinorType())[1]);
                    cb_Value.setVisible(false);
                    l_ValueCb.setVisible(false);
                    l_Value.setVisible(true);
                } else if (p.getMajorType().equals(PDUXlatorList.TYPE_CHARACTER_STRING[0])) {
                    tf_Value.setText("");
                    tf_Value.setVisible(true);
                    tf_ValueType.setVisible(false);
                    cb_Value.setVisible(false);
                    l_ValueCb.setVisible(false);
                    l_Value.setVisible(true);
                }
            }
        } catch (EICLException ex) {
            Main_Frame.showException(ex.getMessage());
        }
    }

    public void b_Close_actionPerformed(ActionEvent e) {
        this.dispose();
    }

    public void b_Send_actionPerformed(ActionEvent e) {
        try {
            if (cb_Point.getSelectedIndex() != -1) {
                Point p = points[cb_Point.getSelectedIndex()];
                String help = "";
                if (cb_Value.isVisible())
                    help = (String) cb_Value.getSelectedItem();
                if (tf_Value.isVisible() && cb_Value.isVisible())
                    help += " " + tf_Value.getText();
                else if (tf_Value.isVisible())
                    help = tf_Value.getText();
                PointPDUXlator xlator = PDUXlatorList.getPointPDUXlator(p.getMajorType(),
                        p.getMinorType());
                xlator.setServiceType(PointPDUXlator.A_GROUPVALUE_WRITE);
                xlator.setASDUfromString(help);
                CEMI_L_DATA data = new CEMI_L_DATA((byte) CEMI_L_DATA.MC_L_DATAREQ,
                        new EIB_Address(), p.getDeviceAddress()[0], xlator.getAPDUByteArray());
               // for (int i=0;i<20;i++) {
                    
                // tunnel.sendFrame(data, CEMI_Connection.WAIT_FOR_CONFIRM);
      
                
                // XXX access on high level
                if (help.equalsIgnoreCase("on"))
                    userLayer.write(p.getDeviceAddress()[0], true);
                else if (help.equalsIgnoreCase("off"))
                    userLayer.write(p.getDeviceAddress()[0], false);
                else {
                	// parse the integer from user input
                    int value;
                    try {
                		value = Integer.parseInt(help);
                	}
                	catch (NumberFormatException nfe) {
                		throw new EICLException("Error on parsing integer field");
                	}                	
                	userLayer.write(p.getDeviceAddress()[0], value, true);
                }
                // XXX
                
                    synchronized (Main_Frame.textArea) {
                        Main_Frame.textArea.append("Message sent to " + cb_Point.getSelectedItem()
                                + " value " + help + "\n");
                    }
                    /*synchronized (this) {
                        try {
                            this.wait(50);
                        }
                        catch (Exception ex) {}
                    }*/
               // }
                
                this.dispose();
            }
        } catch (EICLException ex) {
            Main_Frame.showException(ex.getMessage());
        }
    }

}

class DialogSend_cb_Point_ItemListener implements ItemListener {
    Dialog_Send dp;

    public DialogSend_cb_Point_ItemListener(Dialog_Send _DialogSend) {
        dp = _DialogSend;
    }

    public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
            dp.cb_Point_SelectionChanged(e);

    }

}

class DialogSend_Close_actionAdapter implements ActionListener {
    Dialog_Send point;

    public DialogSend_Close_actionAdapter(Dialog_Send adaptee) {
        point = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        point.b_Close_actionPerformed(e);
    }
}

class DialogSend_Send_actionAdapter implements ActionListener {
    Dialog_Send point;

    public DialogSend_Send_actionAdapter(Dialog_Send adaptee) {
        point = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        point.b_Send_actionPerformed(e);
    }
}
