package tuwien.auto.obix.objects;

import obix.*;

public class FunctionalEntity extends Obj implements IFunctionalEntity
{
	// properties
	private Str _description;
	private List _functions;
	private List _subFE;

	// kids
	public Str description()
	{
		return _description;
	}

	public List functions()
	{
		return _functions;
	}

	public List subFunctionalEntities()
	{
		return _subFE;
	}

	// setter/adder for kids
	public void setDescription(String description)
	{
		remove(_description);
		_description.set(description);
		add(_description);
	}
	
	public void addFunction(GCE gce)
	{
		remove(_functions);
		_functions.add(gce);
		add(_functions);
	}
	
	public void addSubFE(FunctionalEntity subFE)
	{
		remove(_subFE);
		_subFE.add(subFE);
		add(_subFE);
	}
	
	// constructors
	public FunctionalEntity(String name)
	{
		super(name);
		_description = new Str("description", "default");
		_functions = new List("functions");
		_subFE = new List("subFunctionalEntities");
		
		setFacets();
	}
		
	public FunctionalEntity()
	{
		super();
		_description = new Str("description", "default");
		_functions = new List("functions");
		_subFE = new List("subFunctionalEntities");
		
		setFacets();
	}
	
	// set facets
	private void setFacets()
	{
		setIs(new Contract("knx:FunctionalEntity"));
		_subFE.setOf(new Contract("knx:FunctionalEntity"));
		_functions.setOf(new Contract("knx:GCE"));
		add(_description);
		add(_functions);
		add(_subFE);
	}
}
