package tuwien.auto.obix.objects;

import obix.*;

public class GCE extends Obj implements IGCE
{
	// properties
	private Str _description;
	private GroupAddress _ga;
	
	// kids
	public Str description()
	{
		return _description;
	}

	public Obj address()
	{
		return _ga;
	}

	// setter/adder for kids
	public void setDescription(String description)
	{
		remove(_description);
		_description.set(description);
		add(_description);
	}
	
	public void setGroupAddress(GroupAddress ga)
	{
		remove(_ga);
		_ga.add(ga);
		add(_ga);
	}
	
	// constructors
	public GCE(String name)
	{
		super(name);
		_description = new Str("description", "default");
		_ga = new GroupAddress();
		
		setFacets();
	}
		
	public GCE()
	{
		super();
		_description = new Str("description", "default");
		_ga = new GroupAddress();
		
		setFacets();
	}
	
	// set facets
	private void setFacets()
	{
		setIs(new Contract("knx:GCE"));
		add(_description);
		add(_ga);
	}
}
