package tuwien.auto.obix.objects;

import obix.*;

public class GCE_rpoint extends GCE implements IGCE_rpoint
{
	// properties
	private Obj _value;
	
	// kids
	public Obj value()
	{
		return _value;
	}
	
	// setter/adder for kids
	public void setValue(Obj value)
	{
		remove(_value);
		
		// override facets to defaults:
		value.setName("value");
		value.setHref(new Uri("value/"));
		
		_value = value;
		add(_value);
	}

	// constructors
	public GCE_rpoint(String name)
	{
		super(name);
		_value = new Obj("value");
		
		setFacets();
	}
		
	public GCE_rpoint()
	{
		super();
		_value = new Obj("value");
		
		setFacets();
	}
	
	// set facets
	private void setFacets()
	{
		setIs(new Contract("knx:GCE knx:GCE_rpoint"));
		_value.setHref(new Uri("value/"));
		add(_value);
	}
}
