package tuwien.auto.obix.objects;

import obix.*;

public class GroupAddress extends Obj implements IGroupAddress
{
	// properties
	private Int _value;
	private Op _getMainSub;
	private Op _getMainMiddleSub;

	// kids
	public Int rawValue()
	{
		return _value;
	}

	public Op getMainSub()
	{
		return _getMainSub;
	}

	public Op getMainMiddleSub()
	{
		return _getMainMiddleSub;
	}

	// setter/adder for kids
	public void setRawValue(long value)
	{
		remove(_value);
		_value.set(value);
		add(_value);
	}
	
	// constructors
	public GroupAddress()
	{
		super("address");
		_value = new Int("rawValue");
		_getMainSub = new Op("getMainSub");
		_getMainMiddleSub = new Op("getMainMiddleSub");
		
		setFacets();
	}
	
	
	// set facets
	private void setFacets()
	{
		setIs(new Contract("knx:GroupAddress"));
		setHref(new Uri("address/"));
		_getMainSub.setHref(new Uri("getMainSub/"));
		_getMainSub.setIn(new Contract("obix:Nil"));
		_getMainSub.setOut(new Contract("obix:Str"));
		_getMainMiddleSub.setHref(new Uri("getMainMiddleSub/"));
		_getMainMiddleSub.setIn(new Contract("obix:Nil"));
		_getMainMiddleSub.setOut(new Contract("obix:Str"));
		add(_value);
		add(_getMainSub);
		add(_getMainMiddleSub);
	}
}
