package tuwien.auto.eicl;

/**
 * This interface represents the skeleton of a connection identifier container.
 * All relevant message code needed for message exchange are collected in this
 * interface. This containers are passed to the CEMI_Connection classed, which
 * then establishes the respective connection.
 * 
 * @author bernhard erb
 * @see tuwien.auto.eicl.TunnellingConnectionType
 */

public interface CEMIConnectionTypeInfoContainer {
    /**
     * The connection type code.
     * 
     * @return the connection type code
     */
    public short getConnectionTypeCode();

    /**
     * The connection options stored after the 2 byte of the HPAI.
     * 
     * @return the connection options
     */
    public short[] getConnectionOptions();

    /**
     * The Request message code.
     * 
     * @return the message code
     */
    public short getRequest();

    /**
     * The Acknowledge message code.
     * 
     * @return the acknowledge code
     */
    public short getAck();
}