package tuwien.auto.eicl;

import tuwien.auto.eicl.struct.eibnetip.util.*;

/**
 * This class is a container for the Tunnelling Connection. It is passed to
 * constructor of the CEMI_Connection handler. It encapsulates all relevant
 * message codes, whereas the connection option.
 * 
 * @author bernhard erb
 * 
 */

public class TunnellingConnectionType implements CEMIConnectionTypeInfoContainer {
    /**
     * The connection type code.
     */
    public short getConnectionTypeCode() {
        return EIBNETIP_Constants.EIBNETIP_TUNNELING;
    }

    /**
     * The connection options stored after the 2 byte of the HPAI.
     */
    public short[] getConnectionOptions() {
        return new short[] { EIBNETIP_Constants.TUNNEL_LINKLAYER, 0 };
    }

    /**
     * The Request message code.
     */
    public short getRequest() {
        return EIBNETIP_Constants.TUNNELLING_REQUEST;
    }

    /**
     * The Acknowledge message code.
     */
    public short getAck() {
        return EIBNETIP_Constants.TUNNELLING_ACK;
    }

}
