/*
 * Copyright (C) 2005 Bernhard Erb

 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.

 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.

 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package tuwien.auto.eicl.event;

import java.util.EventObject;

/**
 * <p>
 * This object notifies a thread that the connection was closed.
 * 
 * @author bernhard erb
 * @see tuwien.auto.eicl.CEMI_Connection
 */
public class DisconnectEvent extends EventObject {
    static final long serialVersionUID = 1;

    String disconnectMessage;

    /**
     * Constructor
     * 
     * @param arg0
     *            The calling connection object.
     * @param _DisconnectMessage
     *            The reason for connection ending.
     */
    public DisconnectEvent(Object arg0, String _DisconnectMessage) {
        super(arg0);
        disconnectMessage = _DisconnectMessage;

    }

    /**
     * Returns the disconnect message.
     * 
     * @return The disconnect message.
     */
    public String getDisconnectMessage() {
        return disconnectMessage;
    }

}
