/*
 * Copyright (C) 2005 Bernhard Erb

 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.

 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.

 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

/*
 $Log: FrameEvent.java,v $
 Revision 1.5  2005/12/14 22:55:19  gneug
 Eclipse code formatter applied to all source files

 Revision 1.4  2005/12/02 13:15:26  gneug
 JavaDoc comment for getPacket() return type corrected (reported by R. Balazs)

 */

/* 
 TODO: align nomenclature (packet, message, frame)
 */

package tuwien.auto.eicl.event;

import java.util.EventObject;
import tuwien.auto.eicl.struct.cemi.CEMI;

/**
 * <p>
 * The event object passed to the event handlers, communicating the arrival of a
 * new message.
 * 
 * @see tuwien.auto.eicl.event.EICLEventListener
 * @author Bernhard Erb
 */

public class FrameEvent extends EventObject {
    static final long serialVersionUID = 1;

    private CEMI packet;

    /**
     * Constructs a new object
     * 
     * @param source
     *            The source class (calling thread)
     * @param _Packet
     *            The corresponding packet
     */
    public FrameEvent(Object source, CEMI _Packet) {
        super(source);
        packet = _Packet;
    }

    /**
     * Returns the associated message data
     * 
     * @return the cEMI message object
     */
    public CEMI getPacket() {
        return packet;
    }
}
