package tuwien.auto.eicl.struct.cemi;

import tuwien.auto.eicl.util.EICLException;

/**
 * This interface is thought as skeleton for cEMI messages
 * 
 * @author bernhard erb
 * 
 */
public interface CEMI {

    /**
     * Get the byte representation of the CEMI_L_DATA_Message.
     * 
     * @return CEMI_L_DATA message as byte array.
     * @exception EICLException
     *                Processes the IOException as EICLException
     */

    public abstract byte[] toByteArray() throws EICLException;

    /**
     * Get the CEMI_L_DATA application layer data (Message body).
     * 
     * @return application layer data
     */
    public abstract byte[] getData();

    /**
     * Get the length of the message in bytes
     * 
     * @return the message length
     */
    public abstract int getStructLength();

    /**
     * Returns the CEMI_L_DATA message code. See constants.
     * 
     * @return CEMI_L_DATA message code.
     */

    public short getMessageCode();
}