/*
 * Copyright (C) 2005 Bernhard Erb

 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.

 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.

 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package tuwien.auto.eicldemo;

import java.awt.*;

import tuwien.auto.eicldemo.ui.Main_Frame;

/**
 * 10.04.2005
 * 
 * MainClass with main method
 * 
 * @author bernhard
 */

public class MainClass {
    // Constants

    /**
     * the main method
     * 
     * @param args
     */
    public static void main(String[] args) {
        Main_Frame frame = new Main_Frame();
        frame.validate();

        // Center the window
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        frame.setLocation((screenSize.width - frameSize.width) / 2,
                (screenSize.height - frameSize.height) / 2);
        frame.setVisible(true);
    }

    /**
     * Utility for printing message contents
     * 
     * @param _Buffer
     *            the content to print
     */
    public static void printBytes(byte[] _Buffer) {
        for (int i = 0; i < _Buffer.length; i++) {
            short help = _Buffer[i];
            System.out.println(i + "   " + Integer.toHexString(help & 0x00FF));
        }
    }
}
