/*
 * Copyright (C) 2005 Bernhard Erb

 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.

 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.

 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package tuwien.auto.eicldemo.ui;

import javax.swing.JLabel;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JList;
import javax.swing.ListModel;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.ListSelectionModel;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JFrame;
import javax.swing.JScrollPane;

import tuwien.auto.eibpoints.*;
import tuwien.auto.eibxlator.*;
import tuwien.auto.eicl.struct.cemi.EIB_Address;
import tuwien.auto.eicl.util.*;

/**
 * This code was generated using CloudGarden's Jigloo SWT/Swing GUI Builder,
 * which is free for non-commercial use. If Jigloo is being used commercially
 * (ie, by a corporation, company or business for any purpose whatever) then you
 * should purchase a license for each developer using Jigloo. Please visit
 * www.cloudgarden.com for details. Use of Jigloo implies acceptance of these
 * licensing terms. ************************************* A COMMERCIAL LICENSE
 * HAS NOT BEEN PURCHASED for this machine, so Jigloo or this code cannot be
 * used legally for any corporate or commercial purpose.
 * *************************************
 */
public class Dialog_Point extends javax.swing.JDialog {
    public static final long serialVersionUID = 1;

    private JList list_Point;

    private JLabel l_Name;

    private JScrollPane scroll_List;

    private JButton b_New;

    private JButton b_Close;

    private JButton b_Add;

    private JButton b_Delete;

    private JLabel l_Type;

    private JLabel l_Address;

    private JLabel l_Address_Control;

    private JLabel l_Address_Value;

    private JComboBox cb_Type;

    private JComboBox cb_Type_Minor;

    private JTextField tf_PointName;

    private JTextField tf_PointAddress;

    private JTextField tf_PointAddress_Value;

    private JTextField tf_PointAddress_Control;

    private JLabel l_Type_Minor;

    private PointList pointList;

    public Dialog_Point(JFrame frame, PointList _PointList) {
        super(frame);
        pointList = _PointList;
        initGUI();
        setTitle("Point List");
    }

    private void repaintList() {
        ListModel list_PointModel = new DefaultComboBoxModel(pointList.getPointDescriptions());
        list_Point.setModel(list_PointModel);

    }

    private void initGUI() {
        try {
            this.getContentPane().setLayout(null);
            {
                list_Point = new JList();
                repaintList();
                list_Point.setBounds(10, 10, 225, 250);
                list_Point.addListSelectionListener(new DialogPoint_List_SelectionListener(this));
                list_Point.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
                scroll_List = new JScrollPane(list_Point);
                scroll_List.setBounds(10, 10, 225, 250);
                scroll_List.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
                this.getContentPane().add(scroll_List);
            }
            {
                tf_PointAddress = new JTextField();
                this.getContentPane().add(tf_PointAddress);
                tf_PointAddress.setBounds(300, 85, 160, 20);
            }
            {
                l_Address = new JLabel();
                this.getContentPane().add(l_Address);
                l_Address.setText("Address");
                l_Address.setBounds(240, 85, 55, 20);
            }
            {
                tf_PointAddress_Control = new JTextField();
                this.getContentPane().add(tf_PointAddress_Control);
                tf_PointAddress_Control.setBounds(300, 110, 160, 20);
                tf_PointAddress_Control.setVisible(false);
            }
            {
                l_Address_Control = new JLabel();
                this.getContentPane().add(l_Address_Control);
                l_Address_Control.setText("Control");
                l_Address_Control.setBounds(240, 110, 55, 20);
                l_Address_Control.setVisible(false);
            }
            {
                tf_PointAddress_Value = new JTextField();
                this.getContentPane().add(tf_PointAddress_Value);
                tf_PointAddress_Value.setBounds(300, 135, 160, 20);
                tf_PointAddress_Value.setVisible(false);
            }
            {
                l_Address_Value = new JLabel();
                this.getContentPane().add(l_Address_Value);
                l_Address_Value.setText("Value");
                l_Address_Value.setBounds(240, 135, 55, 20);
                l_Address_Value.setVisible(false);
            }
            {
                tf_PointName = new JTextField();
                this.getContentPane().add(tf_PointName);
                tf_PointName.setBounds(300, 60, 160, 20);
            }
            {
                l_Name = new JLabel();
                this.getContentPane().add(l_Name);
                l_Name.setText("Name");
                l_Name.setBounds(240, 60, 50, 20);
            }
            {
                cb_Type = new JComboBox();
                this.getContentPane().add(cb_Type);
                String[] help = PDUXlatorList.getPointTypeMajor().getAllTypeDescription();
                for (int i = 0; i < help.length; i++) {
                    cb_Type.addItem(help[i]);
                }
                cb_Type.setSelectedIndex(-1);
                cb_Type.addItemListener(new DialogPoint_cb_Type_ItemListener(this));
                cb_Type.setBounds(300, 10, 160, 20);
            }
            {
                l_Type = new JLabel();
                this.getContentPane().add(l_Type);
                l_Type.setText("Type");
                l_Type.setBounds(240, 10, 50, 20);
            }
            {
                cb_Type_Minor = new JComboBox();
                this.getContentPane().add(cb_Type_Minor);
                cb_Type_Minor.setBounds(300, 35, 160, 20);
                cb_Type_Minor.setEnabled(false);
            }
            {
                l_Type_Minor = new JLabel();
                this.getContentPane().add(l_Type_Minor);
                l_Type_Minor.setText("Minor");
                l_Type_Minor.setBounds(240, 35, 50, 20);
            }
            {
                b_New = new JButton();
                this.getContentPane().add(b_New);
                b_New.setText("New");
                b_New.setBounds(360, 200, 100, 20);
                b_New.addActionListener(new DialogPoint_New_actionAdapter(this));
            }
            {
                b_Delete = new JButton();
                this.getContentPane().add(b_Delete);
                b_Delete.setText("Delete");
                b_Delete.setBounds(240, 200, 100, 20);
                b_Delete.addActionListener(new DialogPoint_Delete_actionAdapter(this));
            }
            {
                b_Add = new JButton();
                this.getContentPane().add(b_Add);
                b_Add.setText("Add");
                b_Add.setBounds(300, 170, 100, 20);
                b_Add.addActionListener(new DialogPoint_Add_actionAdapter(this));
            }
            {
                b_Close = new JButton();
                this.getContentPane().add(b_Close);
                b_Close.setText("Close");
                b_Close.setBounds(360, 235, 100, 20);
                b_Close.addActionListener(new DialogPoint_Close_actionAdapter(this));
            }
            this.setSize(480, 295);

        } catch (Exception e) {
            Main_Frame.showException(e.getMessage());
        }
    }

    public void b_New_ActionPerformed(ActionEvent e) {
        tf_PointAddress.setText("");
        tf_PointAddress_Control.setText("");
        tf_PointAddress_Value.setText("");
        tf_PointName.setText("");
        cb_Type.setSelectedIndex(-1);
        cb_Type_Minor.setSelectedIndex(-1);
        cb_Type_Minor.setEnabled(false);
        b_Add.setText("Add");
        cb_Type.addItem(PDUXlatorList.TYPE_DIMMING[1]);
        cb_Type.addItem(PDUXlatorList.TYPE_DRIVE_CONTROL[1]);
        l_Address_Control.setVisible(false);
        l_Address_Value.setVisible(false);
        tf_PointAddress_Control.setVisible(false);
        tf_PointAddress_Value.setVisible(false);

    }

    public void b_Add_ActionPerformed(ActionEvent e) {
        try {

            if (b_Add.getText().equals("Add")) {
                if (!tf_PointAddress.getText().equals("") & !tf_PointName.getText().equals("")) {
                    EIB_Address eib = new EIB_Address(tf_PointAddress.getText());

                    if (cb_Type.getSelectedItem().equals(PDUXlatorList.TYPE_DIMMING[1])) {
                        EIB_Address e_position = new EIB_Address(tf_PointAddress.getText());
                        EIB_Address e_control = new EIB_Address(tf_PointAddress_Control.getText());
                        EIB_Address e_value = new EIB_Address(tf_PointAddress_Value.getText());
                        Point p = new Point(tf_PointName.getText() + " position", e_position,
                                PDUXlatorList.TYPE_BOOLEAN[0], PointPDUXlator_Boolean.DPT_SWITCH[0]);
                        pointList.addPoint(p);
                        p = new Point(tf_PointName.getText() + " control", e_control,
                                PDUXlatorList.TYPE_3BIT_CONTROLLED[0],
                                PointPDUXlator_3BitControlled.DPT_Control_Dimming[0]);
                        pointList.addPoint(p);
                        p = new Point(tf_PointName.getText() + " value", e_value,
                                PDUXlatorList.TYPE_8BIT_UNSIGNED[0],
                                PointPDUXlator_8BitUnsigned.DPT_SCALING[0]);
                        pointList.addPoint(p);
                    } else if (cb_Type.getSelectedItem().equals(PDUXlatorList.TYPE_DRIVE_CONTROL[1])) {
                        EIB_Address drive = new EIB_Address(tf_PointAddress.getText());
                        EIB_Address step = new EIB_Address(tf_PointAddress_Control.getText());
                        Point p = new Point(tf_PointName.getText() + " drive", drive,
                                PDUXlatorList.TYPE_BOOLEAN[0], PointPDUXlator_Boolean.DPT_UPDOWN[0]);
                        pointList.addPoint(p);
                        p = new Point(tf_PointName.getText() + " step", step,
                                PDUXlatorList.TYPE_BOOLEAN[0], PointPDUXlator_Boolean.DPT_STEP[0]);
                        pointList.addPoint(p);

                    } else {
                        String major = PDUXlatorList.getPointTypeMajor().getTypeKey(
                                (String) cb_Type.getSelectedItem());
                        String minor = PDUXlatorList.getPointPDUMinor(major).getTypeKey(
                                (String) cb_Type_Minor.getSelectedItem());
                        Point p = new Point(tf_PointName.getText(), eib, major, minor);
                        pointList.addPoint(p);
                    }

                }
            } else { // modify it
                int selected = list_Point.getSelectedIndex();
                Point p = pointList.getAllPoints()[selected];
                pointList.removePoint(p);
                EIB_Address eib = new EIB_Address(tf_PointAddress.getText());
                String major = PDUXlatorList.getPointTypeMajor().getTypeKey(
                        (String) cb_Type.getSelectedItem());
                String minor = PDUXlatorList.getPointPDUMinor(major).getTypeKey(
                        (String) cb_Type_Minor.getSelectedItem());
                p = new Point(tf_PointName.getText(), eib, major, minor);
                pointList.addPoint(p);
            }
            repaintList();
            b_New_ActionPerformed(e);
        } catch (EICLException ex) {
            Main_Frame.showException(ex.getMessage());
        }
    }

    public void b_Delete_ActionPerformed(ActionEvent e) {
        pointList.removePoint(pointList.getAllPoints()[list_Point.getSelectedIndex()]);
        list_Point.setSelectedIndex(-1);
        repaintList();
        b_New_ActionPerformed(e);
    }

    public void b_Close_ActionPerformed(ActionEvent e) {
        this.dispose();
    }

    public void list_SelectionChanged(ListSelectionEvent e) {
        int selected = list_Point.getSelectedIndex();
        if (selected != -1) {
            Point p = pointList.getAllPoints()[selected];

            tf_PointName.setText(p.getDeviceName());
            tf_PointAddress.setText(p.getDeviceAddress()[0].toString());

            try {
                cb_Type.setSelectedItem(PDUXlatorList.getPointTypeMajor().getTypeDescription(
                        p.getMajorType()));
                cb_Type_SelectionChanged(null);
            } catch (EICLException ex) {
                Main_Frame.showException(ex.getMessage());
            }

            try {

                cb_Type_Minor.setSelectedItem(PDUXlatorList.getPointPDUMinor(p.getMajorType()).getTypeDescription(
                        p.getMinorType()));
            } catch (EICLException ex) {
                Main_Frame.showException(ex.getMessage());
            }
            cb_Type.removeItem(PDUXlatorList.TYPE_DIMMING[1]);
            cb_Type.removeItem(PDUXlatorList.TYPE_DRIVE_CONTROL[1]);
            b_Add.setText("Modify");
        }
    }

    public void cb_Type_SelectionChanged(ItemEvent e) {
        cb_Type_Minor.removeAllItems();
        String[] s = new String[0];
        if (cb_Type.getSelectedItem().equals(PDUXlatorList.TYPE_DIMMING[1])) {
            l_Address.setText("Position");
            l_Address_Control.setVisible(true);
            l_Address_Control.setText("Control");
            l_Address_Value.setVisible(true);
            l_Address_Value.setText("Value");
            tf_PointAddress_Control.setVisible(true);
            tf_PointAddress_Value.setVisible(true);
            cb_Type_Minor.setVisible(false);
            l_Type_Minor.setVisible(false);
        } else if (cb_Type.getSelectedItem().equals(PDUXlatorList.TYPE_DRIVE_CONTROL[1])) {
            l_Address.setText("Move");
            l_Address_Control.setVisible(true);
            l_Address_Control.setText("Step");
            l_Address_Value.setVisible(false);
            l_Address_Value.setText("Value");
            tf_PointAddress_Control.setVisible(true);
            tf_PointAddress_Value.setVisible(false);
            cb_Type_Minor.setVisible(false);
            l_Type_Minor.setVisible(false);
        } else {
            try {
                String help = PDUXlatorList.getPointTypeMajor().getTypeKey(
                        cb_Type.getSelectedItem().toString());
                s = PDUXlatorList.getPointPDUMinor(help).getAllTypeDescription();
            } catch (EICLException ex) {
                Main_Frame.showException(ex.getMessage());
            }
            l_Address.setText("Address");
            l_Address_Control.setVisible(false);
            l_Address_Value.setVisible(false);
            tf_PointAddress_Control.setVisible(false);
            tf_PointAddress_Value.setVisible(false);
            cb_Type_Minor.setVisible(true);
            l_Type_Minor.setVisible(true);
        }
        for (int i = 0; i < s.length; i++) {
            cb_Type_Minor.addItem(s[i]);
        }
        cb_Type_Minor.setEnabled(true);
    }
}

class DialogPoint_New_actionAdapter implements ActionListener {
    Dialog_Point point;

    DialogPoint_New_actionAdapter(Dialog_Point adaptee) {
        point = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        point.b_New_ActionPerformed(e);
    }
}

class DialogPoint_Delete_actionAdapter implements ActionListener {
    Dialog_Point point;

    DialogPoint_Delete_actionAdapter(Dialog_Point adaptee) {
        point = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        point.b_Delete_ActionPerformed(e);
    }
}

class DialogPoint_Add_actionAdapter implements ActionListener {
    Dialog_Point point;

    DialogPoint_Add_actionAdapter(Dialog_Point adaptee) {
        point = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        point.b_Add_ActionPerformed(e);
    }
}

class DialogPoint_Close_actionAdapter implements ActionListener {
    Dialog_Point point;

    DialogPoint_Close_actionAdapter(Dialog_Point adaptee) {
        point = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        point.b_Close_ActionPerformed(e);
    }
}

class DialogPoint_List_SelectionListener implements ListSelectionListener {
    Dialog_Point dp;

    public DialogPoint_List_SelectionListener(Dialog_Point _DialogPoint) {
        dp = _DialogPoint;
    }

    public void valueChanged(ListSelectionEvent evt) {
        dp.list_SelectionChanged(evt);
    }
}

class DialogPoint_cb_Type_ItemListener implements ItemListener {
    Dialog_Point dp;

    public DialogPoint_cb_Type_ItemListener(Dialog_Point _DialogPoint) {
        dp = _DialogPoint;
    }

    public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.SELECTED)
            dp.cb_Type_SelectionChanged(e);

    }

}
